Index: sansmodels/src/sans/models/BaseComponent.py
===================================================================
--- sansmodels/src/sans/models/BaseComponent.py	(revision 5eb91544a3ee42b368ccec3ebcf8e95f75b020a2)
+++ sansmodels/src/sans/models/BaseComponent.py	(revision 9ce41c6f9cb652f9c0a81a779f2dd143382ac661)
@@ -85,6 +85,6 @@
             above, numpy arrays must be created the following way:
 
-            qx_prime = numpy.reshape(qx, [3,1])
-            qy_prime = numpy.reshape(qy, [1,3])
+            qx_prime = numpy.reshape(qx, [1,3])
+            qy_prime = numpy.reshape(qy, [3,1])
             
             The method is then called the following way:
@@ -106,9 +106,9 @@
             
             # Create output array
-            iq_array = numpy.zeros([qx.shape[0], qy.shape[1]])
+            iq_array = numpy.zeros([qx.shape[1], qy.shape[0]])
              
-            for i in range(qx.shape[0]):
-                for j in range(qy.shape[1]):
-                    iq_array[i][j] = self.runXY([qx[i][0],qy[0][j]])
+            for j in range(qy.shape[0]):
+                for i in range(qx.shape[1]):
+                    iq_array[j][i] = self.runXY([qx[0][i],qy[j][0]])
             return iq_array
                 
Index: sansmodels/src/sans/models/FractalAbsModel.py
===================================================================
--- sansmodels/src/sans/models/FractalAbsModel.py	(revision 9ce41c6f9cb652f9c0a81a779f2dd143382ac661)
+++ sansmodels/src/sans/models/FractalAbsModel.py	(revision 9ce41c6f9cb652f9c0a81a779f2dd143382ac661)
@@ -0,0 +1,49 @@
+#!/usr/bin/env python
+""" 
+    
+    Provide F(x)= P(|x|)*S(|x|) + bkd
+    Fractal as a BaseComponent model
+"""
+
+from sans.models.FractalModel import FractalModel
+import math
+
+class FractalAbsModel(FractalModel):
+    """
+        Class that evaluates a Fractal function.
+        
+        F(|x|)= P(|x|)*S(|x|) + bkd
+        The model has Seven parameters: 
+            scale        =  Volume fraction
+            radius       =  Block radius
+            fractal_dim  =  Fractal dimension
+            corr_length  =  correlation Length
+            block_sld    =  SDL block
+            solvent_sld  =  SDL solvent
+            background   =  background
+           
+    """
+    def __init__(self):
+        """ Initialization """
+        # Initialize FractalModel 
+
+        FractalModel.__init__(self)
+        ## Name of the model
+        self.name = "Absolute Number Density Fractal"
+        self.description="""
+        I(x)= P(|x|)*S(|x|) + bkd
+        
+        p(x)= scale* V^(2)*delta^(2)* F(x*radius)^(2)
+        F(x) = 3*[sin(x)-x cos(x)]/x**3
+        
+        The model has Seven parameters: 
+        scale        =  Volume fraction
+        radius       =  Block radius
+        fractal_dim  =  Fractal dimension
+        corr_length  =  correlation Length
+        block_sld    =  SDL block
+        solvent_sld  =  SDL solvent
+        background   =  background
+        """
+    def _Fractal(self, x):
+        return FractalModel._Fractal(self, math.fabs(x))
Index: sansmodels/src/sans/models/FractalModel.py
===================================================================
--- sansmodels/src/sans/models/FractalModel.py	(revision 1ed3834d2e968f8ff632d0b368f55ac28174df7a)
+++ sansmodels/src/sans/models/FractalModel.py	(revision 9ce41c6f9cb652f9c0a81a779f2dd143382ac661)
@@ -30,5 +30,5 @@
         """ Initialization """
         
-        # Initialize BaseComponent first, then sphere
+        # Initialize BaseComponent first, then fractal
         BaseComponent.__init__(self)
         
Index: sansmodels/src/sans/models/PorodModel.py
===================================================================
--- sansmodels/src/sans/models/PorodModel.py	(revision 1ed3834d2e968f8ff632d0b368f55ac28174df7a)
+++ sansmodels/src/sans/models/PorodModel.py	(revision 9ce41c6f9cb652f9c0a81a779f2dd143382ac661)
@@ -11,5 +11,5 @@
     """ Class that evaluates a Porod model.
     
-       I(q) = scale/q^4
+       I(q) = scale/q^4 +background
         
     """
@@ -29,5 +29,5 @@
         self.params['background'] = 0.0
         self.description= """The Porod model.
-        I(q) = scale/q^4"""
+        I(q) = scale/q^4 +background"""
 
         ## Parameter details [units, min, max]
Index: sansmodels/src/sans/models/PowerLawAbsModel.py
===================================================================
--- sansmodels/src/sans/models/PowerLawAbsModel.py	(revision 9ce41c6f9cb652f9c0a81a779f2dd143382ac661)
+++ sansmodels/src/sans/models/PowerLawAbsModel.py	(revision 9ce41c6f9cb652f9c0a81a779f2dd143382ac661)
@@ -0,0 +1,38 @@
+#!/usr/bin/env python
+""" 
+    Provide F(x) = scale* (|x|)^(-m) + bkd
+    Power law function as a BaseComponent model
+"""
+
+from sans.models.PowerLawModel import PowerLawModel
+import math
+class PowerLawAbsModel(PowerLawModel):
+    """
+        Class that evaluates a absolute Power_Law model.
+        
+        F(x) = scale* (|x|)^(-m) + bkd
+        
+        The model has three parameters: 
+            m     =  power
+            scale  =  scale factor
+            bkd    =  incoherent background
+    """
+    
+    def __init__(self):
+        """ Initialization """
+        # Initialize PowerLawAbsModel 
+        PowerLawModel.__init__(self)
+        ## Name of the model
+        self.name = "Absolute Power_Law"
+        self.description=""" The Power_Law model.
+        F(x) = scale* (|x|)^(-m) + bkd
+        
+        The model has three parameters: 
+        m     =  power
+        scale  =  scale factor
+        bkd    =  incoherent background"""
+        
+        
+    def _PowerLaw(self, x):
+        return PowerLawModel._PowerLaw(self, math.fabs(x))
+       
Index: sansmodels/src/sans/models/PowerLawModel.py
===================================================================
--- sansmodels/src/sans/models/PowerLawModel.py	(revision 1ed3834d2e968f8ff632d0b368f55ac28174df7a)
+++ sansmodels/src/sans/models/PowerLawModel.py	(revision 9ce41c6f9cb652f9c0a81a779f2dd143382ac661)
@@ -36,5 +36,5 @@
         self.params['background']   = 0.0
         self.description=""" The Power_Law model.
-        F(x) = scale* (|x|)^(-m) + bkd
+        F(x) = scale* (x)^(-m) + bkd
         
         The model has three parameters: 
@@ -51,5 +51,5 @@
     def _PowerLaw(self, x):
         """
-            Evaluate  F(x) = scale* (|x|)^(-m) + bkd
+            Evaluate  F(x) = scale* (x)^(-m) + bkd
            
         """
Index: sansmodels/src/sans/models/c_models/CBinaryHSPSF11Model.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/CBinaryHSPSF11Model.cpp	(revision 5eb91544a3ee42b368ccec3ebcf8e95f75b020a2)
+++ sansmodels/src/sans/models/c_models/CBinaryHSPSF11Model.cpp	(revision 9ce41c6f9cb652f9c0a81a779f2dd143382ac661)
@@ -192,6 +192,6 @@
 	if (PyArray_Check(x) && PyArray_Check(y)) {
 		
-	    x_len = dims[1]= x->dimensions[0];
-        y_len = dims[0]= y->dimensions[1];
+	    x_len = dims[1]= x->dimensions[1];
+        y_len = dims[0]= y->dimensions[0];
 	    
 	    // Make a new double matrix of same dims
@@ -206,6 +206,6 @@
         for ( j=0; j< y_len; j++) {
             for ( i=0; i< x_len; i++) {
-                double x_value = *(double *)(x->data + i*x->strides[0]);
-      		    double y_value = *(double *)(y->data + j*y->strides[1]);
+                double x_value = *(double *)(x->data + i*x->strides[1]);
+      		    double y_value = *(double *)(y->data + j*y->strides[0]);
       			double *result_value = (double *)(result->data +
       			      j*result->strides[0] + i*result->strides[1]);
Index: sansmodels/src/sans/models/c_models/CCoreShellCylinderModel.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/CCoreShellCylinderModel.cpp	(revision 5eb91544a3ee42b368ccec3ebcf8e95f75b020a2)
+++ sansmodels/src/sans/models/c_models/CCoreShellCylinderModel.cpp	(revision 9ce41c6f9cb652f9c0a81a779f2dd143382ac661)
@@ -203,6 +203,6 @@
 	if (PyArray_Check(x) && PyArray_Check(y)) {
 		
-	    x_len = dims[1]= x->dimensions[0];
-        y_len = dims[0]= y->dimensions[1];
+	    x_len = dims[1]= x->dimensions[1];
+        y_len = dims[0]= y->dimensions[0];
 	    
 	    // Make a new double matrix of same dims
@@ -217,6 +217,6 @@
         for ( j=0; j< y_len; j++) {
             for ( i=0; i< x_len; i++) {
-                double x_value = *(double *)(x->data + i*x->strides[0]);
-      		    double y_value = *(double *)(y->data + j*y->strides[1]);
+                double x_value = *(double *)(x->data + i*x->strides[1]);
+      		    double y_value = *(double *)(y->data + j*y->strides[0]);
       			double *result_value = (double *)(result->data +
       			      j*result->strides[0] + i*result->strides[1]);
Index: sansmodels/src/sans/models/c_models/CCoreShellEllipsoidModel.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/CCoreShellEllipsoidModel.cpp	(revision 5eb91544a3ee42b368ccec3ebcf8e95f75b020a2)
+++ sansmodels/src/sans/models/c_models/CCoreShellEllipsoidModel.cpp	(revision 9ce41c6f9cb652f9c0a81a779f2dd143382ac661)
@@ -206,6 +206,6 @@
 	if (PyArray_Check(x) && PyArray_Check(y)) {
 		
-	    x_len = dims[1]= x->dimensions[0];
-        y_len = dims[0]= y->dimensions[1];
+	    x_len = dims[1]= x->dimensions[1];
+        y_len = dims[0]= y->dimensions[0];
 	    
 	    // Make a new double matrix of same dims
@@ -220,6 +220,6 @@
         for ( j=0; j< y_len; j++) {
             for ( i=0; i< x_len; i++) {
-                double x_value = *(double *)(x->data + i*x->strides[0]);
-      		    double y_value = *(double *)(y->data + j*y->strides[1]);
+                double x_value = *(double *)(x->data + i*x->strides[1]);
+      		    double y_value = *(double *)(y->data + j*y->strides[0]);
       			double *result_value = (double *)(result->data +
       			      j*result->strides[0] + i*result->strides[1]);
Index: sansmodels/src/sans/models/c_models/CCoreShellModel.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/CCoreShellModel.cpp	(revision 5eb91544a3ee42b368ccec3ebcf8e95f75b020a2)
+++ sansmodels/src/sans/models/c_models/CCoreShellModel.cpp	(revision 9ce41c6f9cb652f9c0a81a779f2dd143382ac661)
@@ -191,6 +191,6 @@
 	if (PyArray_Check(x) && PyArray_Check(y)) {
 		
-	    x_len = dims[1]= x->dimensions[0];
-        y_len = dims[0]= y->dimensions[1];
+	    x_len = dims[1]= x->dimensions[1];
+        y_len = dims[0]= y->dimensions[0];
 	    
 	    // Make a new double matrix of same dims
@@ -205,6 +205,6 @@
         for ( j=0; j< y_len; j++) {
             for ( i=0; i< x_len; i++) {
-                double x_value = *(double *)(x->data + i*x->strides[0]);
-      		    double y_value = *(double *)(y->data + j*y->strides[1]);
+                double x_value = *(double *)(x->data + i*x->strides[1]);
+      		    double y_value = *(double *)(y->data + j*y->strides[0]);
       			double *result_value = (double *)(result->data +
       			      j*result->strides[0] + i*result->strides[1]);
Index: sansmodels/src/sans/models/c_models/CCylinderModel.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/CCylinderModel.cpp	(revision 5eb91544a3ee42b368ccec3ebcf8e95f75b020a2)
+++ sansmodels/src/sans/models/c_models/CCylinderModel.cpp	(revision 9ce41c6f9cb652f9c0a81a779f2dd143382ac661)
@@ -197,6 +197,6 @@
 	if (PyArray_Check(x) && PyArray_Check(y)) {
 		
-	    x_len = dims[1]= x->dimensions[0];
-        y_len = dims[0]= y->dimensions[1];
+	    x_len = dims[1]= x->dimensions[1];
+        y_len = dims[0]= y->dimensions[0];
 	    
 	    // Make a new double matrix of same dims
@@ -211,6 +211,6 @@
         for ( j=0; j< y_len; j++) {
             for ( i=0; i< x_len; i++) {
-                double x_value = *(double *)(x->data + i*x->strides[0]);
-      		    double y_value = *(double *)(y->data + j*y->strides[1]);
+                double x_value = *(double *)(x->data + i*x->strides[1]);
+      		    double y_value = *(double *)(y->data + j*y->strides[0]);
       			double *result_value = (double *)(result->data +
       			      j*result->strides[0] + i*result->strides[1]);
Index: sansmodels/src/sans/models/c_models/CDiamCylFunc.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/CDiamCylFunc.cpp	(revision 5eb91544a3ee42b368ccec3ebcf8e95f75b020a2)
+++ sansmodels/src/sans/models/c_models/CDiamCylFunc.cpp	(revision 9ce41c6f9cb652f9c0a81a779f2dd143382ac661)
@@ -186,6 +186,6 @@
 	if (PyArray_Check(x) && PyArray_Check(y)) {
 		
-	    x_len = dims[1]= x->dimensions[0];
-        y_len = dims[0]= y->dimensions[1];
+	    x_len = dims[1]= x->dimensions[1];
+        y_len = dims[0]= y->dimensions[0];
 	    
 	    // Make a new double matrix of same dims
@@ -200,6 +200,6 @@
         for ( j=0; j< y_len; j++) {
             for ( i=0; i< x_len; i++) {
-                double x_value = *(double *)(x->data + i*x->strides[0]);
-      		    double y_value = *(double *)(y->data + j*y->strides[1]);
+                double x_value = *(double *)(x->data + i*x->strides[1]);
+      		    double y_value = *(double *)(y->data + j*y->strides[0]);
       			double *result_value = (double *)(result->data +
       			      j*result->strides[0] + i*result->strides[1]);
Index: sansmodels/src/sans/models/c_models/CDiamEllipFunc.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/CDiamEllipFunc.cpp	(revision 5eb91544a3ee42b368ccec3ebcf8e95f75b020a2)
+++ sansmodels/src/sans/models/c_models/CDiamEllipFunc.cpp	(revision 9ce41c6f9cb652f9c0a81a779f2dd143382ac661)
@@ -186,6 +186,6 @@
 	if (PyArray_Check(x) && PyArray_Check(y)) {
 		
-	    x_len = dims[1]= x->dimensions[0];
-        y_len = dims[0]= y->dimensions[1];
+	    x_len = dims[1]= x->dimensions[1];
+        y_len = dims[0]= y->dimensions[0];
 	    
 	    // Make a new double matrix of same dims
@@ -200,6 +200,6 @@
         for ( j=0; j< y_len; j++) {
             for ( i=0; i< x_len; i++) {
-                double x_value = *(double *)(x->data + i*x->strides[0]);
-      		    double y_value = *(double *)(y->data + j*y->strides[1]);
+                double x_value = *(double *)(x->data + i*x->strides[1]);
+      		    double y_value = *(double *)(y->data + j*y->strides[0]);
       			double *result_value = (double *)(result->data +
       			      j*result->strides[0] + i*result->strides[1]);
Index: sansmodels/src/sans/models/c_models/CEllipsoidModel.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/CEllipsoidModel.cpp	(revision 5eb91544a3ee42b368ccec3ebcf8e95f75b020a2)
+++ sansmodels/src/sans/models/c_models/CEllipsoidModel.cpp	(revision 9ce41c6f9cb652f9c0a81a779f2dd143382ac661)
@@ -197,6 +197,6 @@
 	if (PyArray_Check(x) && PyArray_Check(y)) {
 		
-	    x_len = dims[1]= x->dimensions[0];
-        y_len = dims[0]= y->dimensions[1];
+	    x_len = dims[1]= x->dimensions[1];
+        y_len = dims[0]= y->dimensions[0];
 	    
 	    // Make a new double matrix of same dims
@@ -211,6 +211,6 @@
         for ( j=0; j< y_len; j++) {
             for ( i=0; i< x_len; i++) {
-                double x_value = *(double *)(x->data + i*x->strides[0]);
-      		    double y_value = *(double *)(y->data + j*y->strides[1]);
+                double x_value = *(double *)(x->data + i*x->strides[1]);
+      		    double y_value = *(double *)(y->data + j*y->strides[0]);
       			double *result_value = (double *)(result->data +
       			      j*result->strides[0] + i*result->strides[1]);
Index: sansmodels/src/sans/models/c_models/CEllipticalCylinderModel.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/CEllipticalCylinderModel.cpp	(revision 5eb91544a3ee42b368ccec3ebcf8e95f75b020a2)
+++ sansmodels/src/sans/models/c_models/CEllipticalCylinderModel.cpp	(revision 9ce41c6f9cb652f9c0a81a779f2dd143382ac661)
@@ -205,6 +205,6 @@
 	if (PyArray_Check(x) && PyArray_Check(y)) {
 		
-	    x_len = dims[1]= x->dimensions[0];
-        y_len = dims[0]= y->dimensions[1];
+	    x_len = dims[1]= x->dimensions[1];
+        y_len = dims[0]= y->dimensions[0];
 	    
 	    // Make a new double matrix of same dims
@@ -219,6 +219,6 @@
         for ( j=0; j< y_len; j++) {
             for ( i=0; i< x_len; i++) {
-                double x_value = *(double *)(x->data + i*x->strides[0]);
-      		    double y_value = *(double *)(y->data + j*y->strides[1]);
+                double x_value = *(double *)(x->data + i*x->strides[1]);
+      		    double y_value = *(double *)(y->data + j*y->strides[0]);
       			double *result_value = (double *)(result->data +
       			      j*result->strides[0] + i*result->strides[1]);
Index: sansmodels/src/sans/models/c_models/CFlexibleCylinderModel.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/CFlexibleCylinderModel.cpp	(revision 5eb91544a3ee42b368ccec3ebcf8e95f75b020a2)
+++ sansmodels/src/sans/models/c_models/CFlexibleCylinderModel.cpp	(revision 9ce41c6f9cb652f9c0a81a779f2dd143382ac661)
@@ -193,6 +193,6 @@
 	if (PyArray_Check(x) && PyArray_Check(y)) {
 		
-	    x_len = dims[1]= x->dimensions[0];
-        y_len = dims[0]= y->dimensions[1];
+	    x_len = dims[1]= x->dimensions[1];
+        y_len = dims[0]= y->dimensions[0];
 	    
 	    // Make a new double matrix of same dims
@@ -207,6 +207,6 @@
         for ( j=0; j< y_len; j++) {
             for ( i=0; i< x_len; i++) {
-                double x_value = *(double *)(x->data + i*x->strides[0]);
-      		    double y_value = *(double *)(y->data + j*y->strides[1]);
+                double x_value = *(double *)(x->data + i*x->strides[1]);
+      		    double y_value = *(double *)(y->data + j*y->strides[0]);
       			double *result_value = (double *)(result->data +
       			      j*result->strides[0] + i*result->strides[1]);
Index: sansmodels/src/sans/models/c_models/CGaussian.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/CGaussian.cpp	(revision 5eb91544a3ee42b368ccec3ebcf8e95f75b020a2)
+++ sansmodels/src/sans/models/c_models/CGaussian.cpp	(revision 9ce41c6f9cb652f9c0a81a779f2dd143382ac661)
@@ -181,6 +181,6 @@
 	if (PyArray_Check(x) && PyArray_Check(y)) {
 		
-	    x_len = dims[1]= x->dimensions[0];
-        y_len = dims[0]= y->dimensions[1];
+	    x_len = dims[1]= x->dimensions[1];
+        y_len = dims[0]= y->dimensions[0];
 	    
 	    // Make a new double matrix of same dims
@@ -195,6 +195,6 @@
         for ( j=0; j< y_len; j++) {
             for ( i=0; i< x_len; i++) {
-                double x_value = *(double *)(x->data + i*x->strides[0]);
-      		    double y_value = *(double *)(y->data + j*y->strides[1]);
+                double x_value = *(double *)(x->data + i*x->strides[1]);
+      		    double y_value = *(double *)(y->data + j*y->strides[0]);
       			double *result_value = (double *)(result->data +
       			      j*result->strides[0] + i*result->strides[1]);
Index: sansmodels/src/sans/models/c_models/CHayterMSAStructure.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/CHayterMSAStructure.cpp	(revision 42ae1d9f2dd771551fc069abe53a2638ffcba952)
+++ sansmodels/src/sans/models/c_models/CHayterMSAStructure.cpp	(revision 9ce41c6f9cb652f9c0a81a779f2dd143382ac661)
@@ -187,6 +187,6 @@
 	if (PyArray_Check(x) && PyArray_Check(y)) {
 		
-	    x_len = dims[1]= x->dimensions[0];
-        y_len = dims[0]= y->dimensions[1];
+	    x_len = dims[1]= x->dimensions[1];
+        y_len = dims[0]= y->dimensions[0];
 	    
 	    // Make a new double matrix of same dims
@@ -201,6 +201,6 @@
         for ( j=0; j< y_len; j++) {
             for ( i=0; i< x_len; i++) {
-                double x_value = *(double *)(x->data + i*x->strides[0]);
-      		    double y_value = *(double *)(y->data + j*y->strides[1]);
+                double x_value = *(double *)(x->data + i*x->strides[1]);
+      		    double y_value = *(double *)(y->data + j*y->strides[0]);
       			double *result_value = (double *)(result->data +
       			      j*result->strides[0] + i*result->strides[1]);
Index: sansmodels/src/sans/models/c_models/CHollowCylinderModel.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/CHollowCylinderModel.cpp	(revision 5eb91544a3ee42b368ccec3ebcf8e95f75b020a2)
+++ sansmodels/src/sans/models/c_models/CHollowCylinderModel.cpp	(revision 9ce41c6f9cb652f9c0a81a779f2dd143382ac661)
@@ -201,6 +201,6 @@
 	if (PyArray_Check(x) && PyArray_Check(y)) {
 		
-	    x_len = dims[1]= x->dimensions[0];
-        y_len = dims[0]= y->dimensions[1];
+	    x_len = dims[1]= x->dimensions[1];
+        y_len = dims[0]= y->dimensions[0];
 	    
 	    // Make a new double matrix of same dims
@@ -215,6 +215,6 @@
         for ( j=0; j< y_len; j++) {
             for ( i=0; i< x_len; i++) {
-                double x_value = *(double *)(x->data + i*x->strides[0]);
-      		    double y_value = *(double *)(y->data + j*y->strides[1]);
+                double x_value = *(double *)(x->data + i*x->strides[1]);
+      		    double y_value = *(double *)(y->data + j*y->strides[0]);
       			double *result_value = (double *)(result->data +
       			      j*result->strides[0] + i*result->strides[1]);
Index: sansmodels/src/sans/models/c_models/CLamellarFFHGModel.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/CLamellarFFHGModel.cpp	(revision 5eb91544a3ee42b368ccec3ebcf8e95f75b020a2)
+++ sansmodels/src/sans/models/c_models/CLamellarFFHGModel.cpp	(revision 9ce41c6f9cb652f9c0a81a779f2dd143382ac661)
@@ -191,6 +191,6 @@
 	if (PyArray_Check(x) && PyArray_Check(y)) {
 		
-	    x_len = dims[1]= x->dimensions[0];
-        y_len = dims[0]= y->dimensions[1];
+	    x_len = dims[1]= x->dimensions[1];
+        y_len = dims[0]= y->dimensions[0];
 	    
 	    // Make a new double matrix of same dims
@@ -205,6 +205,6 @@
         for ( j=0; j< y_len; j++) {
             for ( i=0; i< x_len; i++) {
-                double x_value = *(double *)(x->data + i*x->strides[0]);
-      		    double y_value = *(double *)(y->data + j*y->strides[1]);
+                double x_value = *(double *)(x->data + i*x->strides[1]);
+      		    double y_value = *(double *)(y->data + j*y->strides[0]);
       			double *result_value = (double *)(result->data +
       			      j*result->strides[0] + i*result->strides[1]);
Index: sansmodels/src/sans/models/c_models/CLamellarModel.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/CLamellarModel.cpp	(revision 5eb91544a3ee42b368ccec3ebcf8e95f75b020a2)
+++ sansmodels/src/sans/models/c_models/CLamellarModel.cpp	(revision 9ce41c6f9cb652f9c0a81a779f2dd143382ac661)
@@ -186,6 +186,6 @@
 	if (PyArray_Check(x) && PyArray_Check(y)) {
 		
-	    x_len = dims[1]= x->dimensions[0];
-        y_len = dims[0]= y->dimensions[1];
+	    x_len = dims[1]= x->dimensions[1];
+        y_len = dims[0]= y->dimensions[0];
 	    
 	    // Make a new double matrix of same dims
@@ -200,6 +200,6 @@
         for ( j=0; j< y_len; j++) {
             for ( i=0; i< x_len; i++) {
-                double x_value = *(double *)(x->data + i*x->strides[0]);
-      		    double y_value = *(double *)(y->data + j*y->strides[1]);
+                double x_value = *(double *)(x->data + i*x->strides[1]);
+      		    double y_value = *(double *)(y->data + j*y->strides[0]);
       			double *result_value = (double *)(result->data +
       			      j*result->strides[0] + i*result->strides[1]);
Index: sansmodels/src/sans/models/c_models/CLamellarPSHGModel.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/CLamellarPSHGModel.cpp	(revision 5eb91544a3ee42b368ccec3ebcf8e95f75b020a2)
+++ sansmodels/src/sans/models/c_models/CLamellarPSHGModel.cpp	(revision 9ce41c6f9cb652f9c0a81a779f2dd143382ac661)
@@ -197,6 +197,6 @@
 	if (PyArray_Check(x) && PyArray_Check(y)) {
 		
-	    x_len = dims[1]= x->dimensions[0];
-        y_len = dims[0]= y->dimensions[1];
+	    x_len = dims[1]= x->dimensions[1];
+        y_len = dims[0]= y->dimensions[0];
 	    
 	    // Make a new double matrix of same dims
@@ -211,6 +211,6 @@
         for ( j=0; j< y_len; j++) {
             for ( i=0; i< x_len; i++) {
-                double x_value = *(double *)(x->data + i*x->strides[0]);
-      		    double y_value = *(double *)(y->data + j*y->strides[1]);
+                double x_value = *(double *)(x->data + i*x->strides[1]);
+      		    double y_value = *(double *)(y->data + j*y->strides[0]);
       			double *result_value = (double *)(result->data +
       			      j*result->strides[0] + i*result->strides[1]);
Index: sansmodels/src/sans/models/c_models/CLamellarPSModel.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/CLamellarPSModel.cpp	(revision 5eb91544a3ee42b368ccec3ebcf8e95f75b020a2)
+++ sansmodels/src/sans/models/c_models/CLamellarPSModel.cpp	(revision 9ce41c6f9cb652f9c0a81a779f2dd143382ac661)
@@ -191,6 +191,6 @@
 	if (PyArray_Check(x) && PyArray_Check(y)) {
 		
-	    x_len = dims[1]= x->dimensions[0];
-        y_len = dims[0]= y->dimensions[1];
+	    x_len = dims[1]= x->dimensions[1];
+        y_len = dims[0]= y->dimensions[0];
 	    
 	    // Make a new double matrix of same dims
@@ -205,6 +205,6 @@
         for ( j=0; j< y_len; j++) {
             for ( i=0; i< x_len; i++) {
-                double x_value = *(double *)(x->data + i*x->strides[0]);
-      		    double y_value = *(double *)(y->data + j*y->strides[1]);
+                double x_value = *(double *)(x->data + i*x->strides[1]);
+      		    double y_value = *(double *)(y->data + j*y->strides[0]);
       			double *result_value = (double *)(result->data +
       			      j*result->strides[0] + i*result->strides[1]);
Index: sansmodels/src/sans/models/c_models/CLorentzian.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/CLorentzian.cpp	(revision 5eb91544a3ee42b368ccec3ebcf8e95f75b020a2)
+++ sansmodels/src/sans/models/c_models/CLorentzian.cpp	(revision 9ce41c6f9cb652f9c0a81a779f2dd143382ac661)
@@ -181,6 +181,6 @@
 	if (PyArray_Check(x) && PyArray_Check(y)) {
 		
-	    x_len = dims[1]= x->dimensions[0];
-        y_len = dims[0]= y->dimensions[1];
+	    x_len = dims[1]= x->dimensions[1];
+        y_len = dims[0]= y->dimensions[0];
 	    
 	    // Make a new double matrix of same dims
@@ -195,6 +195,6 @@
         for ( j=0; j< y_len; j++) {
             for ( i=0; i< x_len; i++) {
-                double x_value = *(double *)(x->data + i*x->strides[0]);
-      		    double y_value = *(double *)(y->data + j*y->strides[1]);
+                double x_value = *(double *)(x->data + i*x->strides[1]);
+      		    double y_value = *(double *)(y->data + j*y->strides[0]);
       			double *result_value = (double *)(result->data +
       			      j*result->strides[0] + i*result->strides[1]);
Index: sansmodels/src/sans/models/c_models/CMultiShellModel.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/CMultiShellModel.cpp	(revision 5eb91544a3ee42b368ccec3ebcf8e95f75b020a2)
+++ sansmodels/src/sans/models/c_models/CMultiShellModel.cpp	(revision 9ce41c6f9cb652f9c0a81a779f2dd143382ac661)
@@ -195,6 +195,6 @@
 	if (PyArray_Check(x) && PyArray_Check(y)) {
 		
-	    x_len = dims[1]= x->dimensions[0];
-        y_len = dims[0]= y->dimensions[1];
+	    x_len = dims[1]= x->dimensions[1];
+        y_len = dims[0]= y->dimensions[0];
 	    
 	    // Make a new double matrix of same dims
@@ -209,6 +209,6 @@
         for ( j=0; j< y_len; j++) {
             for ( i=0; i< x_len; i++) {
-                double x_value = *(double *)(x->data + i*x->strides[0]);
-      		    double y_value = *(double *)(y->data + j*y->strides[1]);
+                double x_value = *(double *)(x->data + i*x->strides[1]);
+      		    double y_value = *(double *)(y->data + j*y->strides[0]);
       			double *result_value = (double *)(result->data +
       			      j*result->strides[0] + i*result->strides[1]);
Index: sansmodels/src/sans/models/c_models/CParallelepipedModel.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/CParallelepipedModel.cpp	(revision 5eb91544a3ee42b368ccec3ebcf8e95f75b020a2)
+++ sansmodels/src/sans/models/c_models/CParallelepipedModel.cpp	(revision 9ce41c6f9cb652f9c0a81a779f2dd143382ac661)
@@ -205,6 +205,6 @@
 	if (PyArray_Check(x) && PyArray_Check(y)) {
 		
-	    x_len = dims[1]= x->dimensions[0];
-        y_len = dims[0]= y->dimensions[1];
+	    x_len = dims[1]= x->dimensions[1];
+        y_len = dims[0]= y->dimensions[0];
 	    
 	    // Make a new double matrix of same dims
@@ -219,6 +219,6 @@
         for ( j=0; j< y_len; j++) {
             for ( i=0; i< x_len; i++) {
-                double x_value = *(double *)(x->data + i*x->strides[0]);
-      		    double y_value = *(double *)(y->data + j*y->strides[1]);
+                double x_value = *(double *)(x->data + i*x->strides[1]);
+      		    double y_value = *(double *)(y->data + j*y->strides[0]);
       			double *result_value = (double *)(result->data +
       			      j*result->strides[0] + i*result->strides[1]);
Index: sansmodels/src/sans/models/c_models/CSchulz.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/CSchulz.cpp	(revision 5eb91544a3ee42b368ccec3ebcf8e95f75b020a2)
+++ sansmodels/src/sans/models/c_models/CSchulz.cpp	(revision 9ce41c6f9cb652f9c0a81a779f2dd143382ac661)
@@ -181,6 +181,6 @@
 	if (PyArray_Check(x) && PyArray_Check(y)) {
 		
-	    x_len = dims[1]= x->dimensions[0];
-        y_len = dims[0]= y->dimensions[1];
+	    x_len = dims[1]= x->dimensions[1];
+        y_len = dims[0]= y->dimensions[0];
 	    
 	    // Make a new double matrix of same dims
@@ -195,6 +195,6 @@
         for ( j=0; j< y_len; j++) {
             for ( i=0; i< x_len; i++) {
-                double x_value = *(double *)(x->data + i*x->strides[0]);
-      		    double y_value = *(double *)(y->data + j*y->strides[1]);
+                double x_value = *(double *)(x->data + i*x->strides[1]);
+      		    double y_value = *(double *)(y->data + j*y->strides[0]);
       			double *result_value = (double *)(result->data +
       			      j*result->strides[0] + i*result->strides[1]);
